program walls;
type
    Arr=array [1..100,1..100] of byte;
    Arr_queue=array [1..2,1..10000] of byte;
    Arr_pri=array [1..10000] of byte;
var
    a,b:Arr;
    Q:Arr_queue;
    pr:Arr_pri;
    i,j,n,m,n1,m1,size_q,ans:integer;

procedure ReadData;
begin
 ReadLn(m,n);
 for i:=1 to m do
  begin
   for j:=1 to n do
    begin
     Read(a[i,j]);
     if a[i,j]=2
      then
       begin
        m1:=i;
        n1:=j;
       end;
    end;
  end;
end;

procedure Enqueue(x,y,z:integer);
begin
 size_q:=size_q+1;
 Q[1,size_q]:=x;
 Q[2,size_q]:=y;
 pr[size_q]:=z;
end;

procedure FindMin(var x,y:integer);
var
    min,index_min,i:integer;
begin
 index_min:=1;
 min:=pr[1];
 for i:=2 to size_q do
  begin
   if pr[i]<min
    then
     begin
      min:=pr[i];
      index_min:=i;
     end;
  end;
 x:=Q[1,index_min];
 y:=Q[2,index_min];
end;

procedure Dequeue(x,y:integer);
var
    i,k:integer;
    flag:boolean;
begin
 flag:=false;
 i:=1;
 while (i<=size_q) and (flag=false) do
  begin
   if (Q[1,i]=x) and (Q[2,i]=y)
    then
     begin
      k:=i;
      flag:=true;
     end;
   i:=i+1;
  end;
 for i:=k to size_q+1 do
  begin
   Q[1,i]:=Q[1,i+1];
   Q[2,i]:=Q[2,i+1];
   pr[i]:=pr[i+1];
  end;
 size_q:=size_q-1;
end;

procedure SolveTask;
begin

 Enqueue(m1,n1,0);
 b[m1,n1]:=1;
 a[m1,n1]:=0;
 while size_q<>0 do
  begin

   FindMin(i,j);
   if (b[i,j-1]=0) and (j-1>=1)
    then
     begin
      a[i,j-1]:=a[i,j]+a[i,j-1];
      Enqueue(i,j-1,a[i,j-1]);
      b[i,j-1]:=1;
     end;
   if (b[i,j+1]=0) and (j+1<=n)
    then
     begin
      a[i,j+1]:=a[i,j]+a[i,j+1];
      Enqueue(i,j+1,a[i,j+1]);
      b[i,j+1]:=1;
     end;
   if (b[i-1,j]=0) and (i-1>=1)
    then
     begin
      a[i-1,j]:=a[i,j]+a[i-1,j];
      Enqueue(i-1,j,a[i-1,j]);
      b[i-1,j]:=1;
     end;
   if (b[i+1,j]=0) and (i+1<=m)
    then
     begin
      a[i+1,j]:=a[i,j]+a[i+1,j];
      Enqueue(i+1,j,a[i+1,j]);
      b[i+1,j]:=1;
     end;
   Dequeue(i,j);
  end;
 ans:=maxint;
 for i:=1 to n do
  if a[1,i]<ans
   then
    ans:=a[1,i];
 for i:=1 to m do
  if a[i,1]<ans
   then
    ans:=a[i,1];
 for i:=1 to n do
  if a[m,i]<ans
   then
    ans:=a[m,i];
 for i:=1 to m do
  if a[i,n]<ans
   then
    ans:=a[i,n];
end;

procedure WriteData;
begin
 WriteLn(ans);
end;

begin
 ReadData;
 SolveTask;
 WriteData;
end.