program Chess;
function Inside(Coord, Min, Max: integer): boolean;
begin
	Inside := (Min <= Coord) and (Coord <= Max);
end;
var
	W, H, X1, Y1, X2, Y2: integer;
	AX, AY, BX, BY, P, Q: integer;
	I, J, K: integer;
	PathX, PathY: array[1..8,1..8] of integer;
	QueueX, QueueY: array[1..8*8] of integer;
	QHead, QTail: integer;
	Len: integer;
	ResX, ResY: array[1..8*8] of integer;
	ResL: integer;
begin
	Read( W, H, X1, Y1, X2, Y2);
	for I := 1 to 8 do
		for J := 1 to 8 do
		begin
			PathX[I,J] := -1;
			PathY[I,J] := -1;
		end;
	PathX[X2,Y2] := 0;
	PathY[X2,Y2] := 0;
	QHead := 1;
	QTail := 1;
	QueueX[QTail] := X2;
	QueueY[QTail] := Y2;
	QTail := QTail+1;
	while (PathX[X1,Y1] = -1) and (PathY[X1,Y1] = -1) do
	begin
		AX := QueueX[QHead];
		AY := QueueY[QHead];
		QHead := QHead+1;
		for P := -1 to 1 do
			for Q := -1 to 1 do
				if (P <> 0) or (Q <> 0) then
				begin
					BX := AX; BY := AY;
					while inside(BX, 1, 8) and inside(BY, 1, 8) and
						not (inside(BX, 5-W div 2, 4+W div 2) and
							inside(BY, 5-H div 2, 4+H div 2)) do
					begin
						if (PathX[BX,BY] = -1) and (PathY[BX,BY] = -1) then
						begin
							PathX[BX,BY] := AX;
							PathY[BX,BY] := AY;
							QueueX[QTail] := BX;
							QueueY[QTail] := BY;
							QTail := QTail+1;
						end;
						BX := BX+P; BY := BY+Q;
					end;
				end;
	end;
	ResL := 0;
	AX := X1; AY := Y1;
	while not ((AX = 0) and (AY = 0)) do
	begin
		ResL := ResL+1;
		ResX[ResL] := AX;
		ResY[ResL] := AY;
		BX := PathX[AX,AY];
		BY := PathY[AX,AY];
		AX := BX; AY := BY;
	end;
	Writeln( ResL-1);
	for K := 1 to ResL do
		Writeln(ResX[K], ' ', ResY[K]);
end.

